"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceBase = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
let ServiceBase = class ServiceBase {
    constructor(repo) {
        this.repo = repo;
    }
    get entity() {
        return this.repo.target;
    }
    async findOneBy(options, manager) {
        if (manager) {
            return manager.findOne(this.entity, options);
        }
        return this.repo.findOne(options);
    }
    async findAllBy(options, manager) {
        if (manager) {
            return manager.find(this.entity, options);
        }
        return this.repo.find(options);
    }
    async createOneBy(params, manager) {
        if (manager) {
            return (await manager.insert(this.entity, params)).generatedMaps[0];
        }
        return (await this.repo.insert(params))
            .generatedMaps[0];
    }
    async createAllBy(params, manager) {
        const createEntities = params.map((param) => this.repo.create(param));
        if (manager) {
            return manager.save(this.entity, createEntities);
        }
        return this.repo.save(createEntities);
    }
    async createOneIfNotExistBy(params, manager) {
        const createEntitie = this.repo.create(params);
        if (manager) {
            return manager.save(this.entity, createEntitie);
        }
        return this.repo.save(createEntitie);
    }
    async createOrUpdateAllBy(params, conflictPathsOrOptions, manager) {
        const createEntities = params.map((param) => this.repo.create(param));
        if (manager) {
            return (await manager.upsert(this.entity, createEntities, conflictPathsOrOptions)).generatedMaps;
        }
        return (await this.repo.upsert(createEntities, conflictPathsOrOptions))
            .generatedMaps;
    }
    async updateOneBy(where, set, manager) {
        if (manager) {
            return manager.update(this.entity, where, set);
        }
        return this.repo.update(where, set);
    }
    async deleteOneBy(where, manager) {
        if (manager) {
            return manager.delete(this.entity, where);
        }
        return this.repo.delete(where);
    }
};
ServiceBase = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [typeorm_1.Repository])
], ServiceBase);
exports.ServiceBase = ServiceBase;
//# sourceMappingURL=service.base.js.map