import { TypeOrmCrudService } from "@nestjsx/crud-typeorm";
import { Farm } from "./farm.entity";
import { DeepPartial, DeleteResult, EntityManager, FindOperator, FindOptionsWhere, InsertResult, Repository, UpdateResult } from "typeorm";
export declare class FarmService extends TypeOrmCrudService<Farm> {
    readonly repo: Repository<Farm>;
    private readonly entity;
    private readonly relations;
    private readonly recursiveRelations;
    constructor(repo: Repository<Farm>);
    findOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Farm>;
    findAllBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Farm[]>;
    createOneBy(params: DeepPartial<Farm>, manager?: EntityManager): Promise<Farm>;
    createAllBy(params: DeepPartial<Farm>[], manager?: EntityManager): Promise<Farm[]>;
    createAllIfNotExistBy(params: DeepPartial<Farm>[], manager?: EntityManager): Promise<InsertResult>;
    updateOneBy(where: FindOptionsWhere<Farm>, set: {
        [K in keyof Farm]?: any;
    }, manager?: EntityManager): Promise<UpdateResult>;
    deleteOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<DeleteResult>;
}
